/******************************************************************************
 *            g_integration_pgn.c                                             *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

/* Routines d'intégration d'une partie pgn en tant que partie actuelle */

#include "g_integration_pgn.h"

// Fonction de recherche d'une expression dans un texte. Renvoie le nombre de
// fois trouvée.
guint g_compteur_mot(gchar *text, const gchar *string)
{
	guint compteur=0;
	gchar *ligne_tmp2, *ligne_tmp3;

	ligne_tmp3 = text;
	while (1)
	{
	  ligne_tmp2 = strstr (ligne_tmp3, string);

	  if (ligne_tmp2 != NULL)
	    {
	      compteur++;
	      ligne_tmp3 = ligne_tmp2 + 1;
	    }
	  else
	    break;
	}
	return compteur;
}

void g_double_clic_list(GtkTreeView *tree_view, GtkTreePath *path,
												GtkTreeViewColumn *column, gpointer user_data)
{
	FILE *Fichier;
	GtkTreeIter iter;
	GtkListStore *parties_a_integrer=(GtkListStore *)user_data;
	gchar *buffer;
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

	// Pour récupérer dans iter la ligne sélectionnée
	gtk_tree_selection_get_selected (gtk_tree_view_get_selection(tree_view),
																																	NULL, &iter);
	// On récupère chaque donnée de l'iter sélectionné
	gtk_tree_model_get (GTK_TREE_MODEL (parties_a_integrer),
		&iter, 9, &buffer, -1);

	gchar *chemin =
				g_strdup_printf ("%s/.linechec.tmp", g_get_tmp_dir());
	gchar *chemin2 =
				g_strdup_printf ("/bin/rm -f %s/.linechec.tmp", g_get_tmp_dir());

	Fichier = fopen (chemin, "w");
	fprintf (Fichier, "%s", g_locale_from_utf8 (buffer, -1, NULL, NULL, NULL));
	fclose (Fichier);
	g_initialisation_jeu ();
	if (incorporation_pgn_dans_jeu (chemin) == 0)
		gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), TRUE);
	g_spawn_command_line_sync (chemin2, NULL, NULL, NULL, NULL);
	g_free (chemin);
	g_free (chemin2);
	g_free (buffer);

	//Fermeture de la fenêtre de sélection
	gtk_widget_destroy(gtk_widget_get_ancestor(GTK_WIDGET(tree_view), GTK_TYPE_DIALOG));
}

void g_verif_nbre_parties (gchar * filename)
{
  gchar *file_buffer = NULL;
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  /*On va déterminer s'il existe plusieurs parties dans le fichier à intégrer.
    Si oui, on va découper ce fichier en autant de parties qu'il comporte pour 
		les afficher dans une fenêtre de choix. */
  // 1 - Chargement complet du fichier
  if (g_file_get_contents (filename, &file_buffer, NULL, NULL))
	{
		gchar *Ligne = NULL;
		gchar *ligne_tmp2 = NULL;
		
		// 2 - Recherche du nombre de fois que l'on trouve "[Event" qui signifie le
		//		début d'une partie.
		guint compteur;
		compteur=g_compteur_mot(file_buffer, "[Event \"");
		
		// 3 - Si le nombre est > 1, alors il faut découper, sinon on envoie le
		//		fichier au traitement.
		if (compteur > 1)
		{
			GtkWidget *fenetre_principale;
			fenetre_principale=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "fenetre_principale"));
			gchar *buffer;
			GtkWidget *dialogue;
			GtkWidget *boite_hor;	// Boite horizontale contenant la liste des parties
														// à intégrer à gauche et les parties intégrées à
														// droite.
			GtkWidget *Asc_parties_a_integrer;
			GtkWidget *fen_parties_a_integrer;
			GtkListStore *parties_a_integrer;
			GtkCellRenderer *renderer;	// Pour la création et l'affichage des titres.
			GtkTreeViewColumn *column;	// Pour la création et l'affichage des titres.
			gchar *ligne;
			gchar *ligne_temp;
			GtkTreeIter iter;
			GtkWidget *progress;
			gdouble fraction, valeur;
			gchar *pourcent;
			gchar *label;
	
			// Création d'une fenêtre de dialogue
			dialogue =
			gtk_dialog_new_with_buttons
				("Chargement d'une partie (extension .pgn)",
				 GTK_WINDOW (fenetre_principale), GTK_DIALOG_MODAL,
				 GTK_STOCK_CANCEL, GTK_RESPONSE_NO, GTK_STOCK_OPEN,
				 GTK_RESPONSE_ACCEPT, NULL);
			gtk_widget_set_size_request (dialogue, 600, 500);
	
			ligne_tmp2 = g_strdup_printf(
													"Le fichier sélectionné comporte %d parties.\n\
Veuillez patientez pendant la création de la liste.", compteur);
			gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogue)->vbox),
																	gtk_label_new (ligne_tmp2), TRUE, TRUE, 0);
			g_free (ligne_tmp2);
	
			// Boite horizontale
			boite_hor = gtk_hbox_new (FALSE, 0);
			gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogue)->vbox),
							boite_hor, TRUE, TRUE, 0);
	
			// Création de la fenêtre de la liste des parties : la 10ème colonne est
			// cachée. Elle contient la partie complète de la ligne considérée.
			parties_a_integrer =
				gtk_list_store_new (10, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING,
					G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
					G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
			// Création du widget d'affichage
			fen_parties_a_integrer =
				gtk_tree_view_new_with_model (GTK_TREE_MODEL(parties_a_integrer));
			gtk_widget_set_size_request (fen_parties_a_integrer, 110, 300);
			// Autorise le double-clic sur les lignes
			g_signal_connect(G_OBJECT(fen_parties_a_integrer), "row-activated",
				(GCallback)g_double_clic_list, parties_a_integrer);

			renderer = gtk_cell_renderer_text_new ();
			column =
				gtk_tree_view_column_new_with_attributes ("N°", renderer, "text",
										0, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Evènement", renderer, "text",
										1, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Site", renderer,
										"text", 2, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Date", renderer,
										"text", 3, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Blanc", renderer,
										"text", 4, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Noir", renderer,
										"text", 5, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Résultat", renderer, "text",
										6, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Elo blanc", renderer,
										"text", 7, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("Elo noir", renderer,
										"text", 8, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			column =
				gtk_tree_view_column_new_with_attributes ("complet", renderer,
										"text", 9, NULL);
			gtk_tree_view_append_column (GTK_TREE_VIEW (fen_parties_a_integrer),
								 column);
			gtk_tree_view_column_set_visible (gtk_tree_view_get_column
								(GTK_TREE_VIEW(fen_parties_a_integrer), 9), FALSE);
	
			Asc_parties_a_integrer = gtk_scrolled_window_new (NULL, NULL);
			gtk_container_set_border_width (GTK_CONTAINER
							(Asc_parties_a_integrer), 4);
			gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
							(Asc_parties_a_integrer),
							GTK_POLICY_AUTOMATIC,
							GTK_POLICY_AUTOMATIC);
			gtk_container_add (GTK_CONTAINER (Asc_parties_a_integrer),
						 fen_parties_a_integrer);
	
			gtk_tree_view_set_headers_clickable (GTK_TREE_VIEW
									 (fen_parties_a_integrer),
									 FALSE);
	
			progress = gtk_progress_bar_new ();
			gtk_progress_bar_set_ellipsize (GTK_PROGRESS_BAR (progress),
							PANGO_ELLIPSIZE_END);
			gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialogue)->vbox), progress,
						FALSE, FALSE, 4);
	
			// Affichage de la fenêtre
			gtk_widget_show_all (dialogue);
	
			// Extraction des différentes parties et insertion dans
			// fen_parties_a_integrer.
			Ligne = file_buffer;
			valeur = 1 / ((gdouble) compteur);
			fraction = valeur;
			gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progress), fraction);
			compteur = 1;
	
			while (1)
			{
				pourcent = g_strdup_printf ("%d parties", (int) (compteur));
				gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progress), pourcent);
				g_free (pourcent);
				gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progress), fraction);
				fraction = fraction + valeur;
				if (fraction > 1)
				fraction = 1;
				
				// Permet l'affichage des parties au fur et à mesure du chargement
				while (gtk_events_pending ())
					gtk_main_iteration ();
				
				ligne_tmp2 = strstr (Ligne, "[Event \"");
				if (ligne_tmp2 == Ligne)
				ligne_tmp2 = strstr (Ligne + 8, "[Event \"");
				if (ligne_tmp2 == NULL)
				ligne_tmp2 = file_buffer + strlen (file_buffer);
				buffer = g_strndup (Ligne, ligne_tmp2 - Ligne);
				
				// ligne_temp contient toutes les entêtes descriptives de la partie
				ligne_temp =
				g_strndup (buffer, g_strrstr (buffer, "]") - buffer + 1);
				// Création d'une nouvelle ligne et insertion du compteur
				gtk_list_store_append (parties_a_integrer, &iter);
				gtk_list_store_set (parties_a_integrer, &iter, 0, compteur, -1);
				// Extraction du nom de l'évènement et insertion
				ligne = g_strndup (strstr (ligne_temp, "[Event \"") + 8,
														strstr (strstr (ligne_temp, "[Event \"") + 8,
				 									"\"]") - (strstr (ligne_temp, "[Event \"") + 8));
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 1, label, -1);
				g_free (label);

				// Extraction du site et insertion
				if (strstr (ligne_temp, "[Site \""))
					ligne = g_strndup (strstr (ligne_temp, "[Site \"") + 7,
				 											strstr (strstr (ligne_temp, "[Site \"") + 7,
					 										"\"]") - (strstr (ligne_temp, "[Site \"") + 7));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 2, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction de la date et insertion
				if (strstr (ligne_temp, "[Date \""))
					ligne = g_strndup (strstr (ligne_temp, "[Date \"") + 7,
															strstr (strstr (ligne_temp, "[Date \"") + 7,
															"\"]") - (strstr (ligne_temp,"[Date \"") + 7));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 3, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction des nom et prénom du joueur blanc et insertion
				if (strstr (ligne_temp, "[White \""))
				ligne = g_strndup (strstr (ligne_temp, "[White \"") + 8,
				 										strstr (strstr (ligne_temp, "[White \"") + 8,
					 									"\"]") - (strstr (ligne_temp, "[White \"") + 8));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 4, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction des nom et prénom du joueur noir et insertion
				if (strstr (ligne_temp, "[Black \""))
				ligne = g_strndup (strstr (ligne_temp, "[Black \"") + 8,
				 										strstr (strstr (ligne_temp, "[Black \"") + 8,
					 									"\"]") - (strstr (ligne_temp, "[Black \"") + 8));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 5, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction du résultat et insertion
				if (strstr (ligne_temp, "[Result \""))
				ligne = g_strndup (strstr (ligne_temp, "[Result \"") + 9,
				 										strstr (strstr (ligne_temp, "[Result \"") + 9,
					 									"\"]") - (strstr (ligne_temp, "[Result \"") + 9));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 6, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction des points Elo du joueur blanc et insertion
				if (strstr (ligne_temp, "[WhiteElo \""))
				ligne = g_strndup (strstr (ligne_temp, "[WhiteElo \"") + 11,
				 										strstr (strstr (ligne_temp, "[WhiteElo \"") + 11,
					 									"\"]") - (strstr (ligne_temp,"[WhiteElo \"") + 11));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 7, label, -1);
				g_free (label);
				g_free (ligne);
				// Extraction des points Elo du joueur noir et insertion
				if (strstr (ligne_temp, "[BlackElo \""))
				ligne = g_strndup (strstr (ligne_temp, "[BlackElo \"") + 11,
				 										strstr (strstr (ligne_temp, "[BlackElo \"") + 11,
					 									"\"]") - (strstr (ligne_temp,"[BlackElo \"") + 11));
				else
				ligne = g_strdup ("?");
				label = g_locale_to_utf8 (ligne, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 8, label, -1);
				g_free (label);
				g_free (ligne);
				// Sauvegarde de la partie complète dans la dernière colonne cachée à
				// l'utilisateur.
				label = g_locale_to_utf8 (buffer, -1, NULL, NULL, NULL);
				gtk_list_store_set (parties_a_integrer, &iter, 9, label, -1);
				g_free (label);
				g_free (buffer);
				g_free (ligne_temp);
				
				compteur++;
				Ligne = ligne_tmp2;
				
				if (ligne_tmp2 == file_buffer + strlen (file_buffer))
				break;
			}
	
			gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogue)->vbox),
							gtk_label_new ("Choisissez une partie dans la liste."),
							TRUE, TRUE, 0);
			gtk_box_pack_start (GTK_BOX (boite_hor), Asc_parties_a_integrer,
							TRUE, TRUE, 0);
			gtk_widget_show_all (Asc_parties_a_integrer);
	
			// Contrôle des différents boutons
			switch (gtk_dialog_run (GTK_DIALOG (dialogue)))
			{
				// L'utilisateur accepte la sélection
				case GTK_RESPONSE_ACCEPT:
				{
					g_double_clic_list(GTK_TREE_VIEW(fen_parties_a_integrer), NULL,
												NULL, parties_a_integrer);
					break;
				}

				// L'utilisateur annule
				case GTK_RESPONSE_NO:
				{
					gtk_widget_destroy (dialogue);
				}
			}
		}
    else
		{
			g_initialisation_jeu ();
			if (incorporation_pgn_dans_jeu (filename) == 0)
				gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), TRUE);
		}
	}
	if (file_buffer) g_free (file_buffer);
}

void g_integration_partie_pgn ()
{
  GtkFileFilter *filter;
  GtkWidget *dialog;
  gchar *tmp;
	GtkWidget *fenetre_principale;
	fenetre_principale=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "fenetre_principale"));
	GdkPixbuf *icone_appli;
	icone_appli=(GdkPixbuf*)
								(gtk_data_list_get_by_name(widget_list, "icone_appli"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));

  dialog =
    gtk_file_chooser_dialog_new ("Chargement d'une partie (extension .pgn)",
				 GTK_WINDOW (fenetre_principale),
				 GTK_FILE_CHOOSER_ACTION_OPEN,
				 GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				 GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);

  // affectation d'une icône à la fenêtre
  gtk_window_set_icon (GTK_WINDOW (GTK_WIDGET (dialog)), icone_appli);

  // On fixe le répertoire de sauvegarde
  tmp = g_key_file_get_string (key_file_config, "DIRECTORY", "save", NULL);
  if (tmp)
	{
		gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), tmp);
		g_free (tmp);
	}

  // Un seul fichier sélectionné à la fois.
  gtk_file_chooser_set_select_multiple (GTK_FILE_CHOOSER (dialog), FALSE);

  // Application d'un filtre pour n'autoriser que le chargement des
	// fichiers .pgn
  filter = gtk_file_filter_new ();
  gtk_file_filter_add_pattern (filter, "*.pgn");
  gtk_file_chooser_set_filter (GTK_FILE_CHOOSER (dialog), filter);

  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
    {
      char *filename=NULL;

      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));

      g_verif_nbre_parties (filename);
      g_free (filename);

      // Autorisation de navigation
      gtk_widget_set_sensitive (bouton_debut, TRUE);
      gtk_widget_set_sensitive (bouton_recul, TRUE);

      // Initialisation du tablau des pièces prises
      g_affichage_pieces_prises ();

      // On redessine l'échiquier
      gtk_widget_queue_draw (Zone_dessin);
    }

  gtk_widget_destroy (dialog);
}

void g_enregistrement_partie_pgn (gint choix)
{
  GtkWidget *dialog;		// Fenetre d'enregistrement

  GtkFileFilter *filter;
  gchar *chemin = NULL;
  gchar *tmp;
	GtkWidget *fenetre_principale;
	fenetre_principale=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "fenetre_principale"));
	GdkPixbuf *icone_appli;
	icone_appli=(GdkPixbuf*)
								(gtk_data_list_get_by_name(widget_list, "icone_appli"));
  dialog = gtk_file_chooser_dialog_new
    ("Enregistrement d'une partie (extension .pgn)",
     GTK_WINDOW (fenetre_principale), GTK_FILE_CHOOSER_ACTION_SAVE,
     GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE,
     GTK_RESPONSE_ACCEPT, NULL);

  // affectation d'une icône à la fenêtre
  gtk_window_set_icon (GTK_WINDOW (GTK_WIDGET (dialog)), icone_appli);

  // On fixe le répertoire de travail
  tmp = g_key_file_get_string (key_file_config, "DIRECTORY", "save", NULL);
  if (tmp)
    {
      chemin = g_strdup_printf ("%s/sauvegardes/", tmp);
      gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), chemin);
      g_free (chemin);
      g_free (tmp);
    }

  // Un seul fichier sélectionné à la fois.
  gtk_file_chooser_set_select_multiple (GTK_FILE_CHOOSER (dialog), FALSE);

  // Application d'un filtre pour n'autoriser que le chargement des fichiers .pgn
  filter = gtk_file_filter_new ();
  gtk_file_filter_add_pattern (filter, "*.pgn");
  gtk_file_chooser_set_filter (GTK_FILE_CHOOSER (dialog), filter);

  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
    {
      char *filename;

      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
      enregistrement_fichier_pgn (filename);
      g_free (filename);

      switch (choix)
	{
	case NOUVELLE_PARTIE:
	  {
	    g_initialisation_jeu ();
	    break;
	  }
	case CHARGER_PARTIE:
	  {
	    g_initialisation_jeu ();
	    g_integration_partie_pgn ();
	    break;
	  }
	case QUITTER:
	  {
	    gtk_main_quit ();
	  }
	}
    }

  gtk_widget_destroy (dialog);
}
